// sendChatMessage(msg, sender, team, target)
global.sendChatMessage = '
    var msg, target;
    msg = argument0;
    target = argument3;

    while(msg != "") {
        write_ubyte(global.chatSendBuffer, argument1);
        if (argument1 < 200) {
            write_ubyte(global.chatSendBuffer, argument2);
        }

        write_ubyte(global.chatSendBuffer, min(255, string_length(msg)));
        write_string(global.chatSendBuffer, string_copy(msg, 0, 255));
        msg = string_copy(msg, 256, string_length(msg));

        if (target <= 0) {
            target = Player;
        }
        with(target) {
            if (hasChat = true) {
                if (argument2 > 0 && team == argument2 - 1 || argument2 == 0) {
                    PluginPacketSendTo(global.chatPacketID, global.chatSendBuffer, id);
                }
            }
        }
        buffer_clear(global.chatSendBuffer);
    }
';

// sendChatMessageClient(msg, team)
global.sendChatMessageClient = '
    write_ubyte(global.chatSendBuffer, argument1 + 1);
    write_ubyte(global.chatSendBuffer, min(255, string_length(argument0)));
    write_string(global.chatSendBuffer,string_copy(argument0, 0, 255));
    PluginPacketSend(global.chatPacketID, global.chatSendBuffer);
    buffer_clear(global.chatSendBuffer);
';

// addChatMessage(msg, sender, team)
global.addChatMessage = '
    var muted, sender, msg, i;
    muted = false;
    msg = argument0;

    if (argument1 < 200) {
        sender = ds_list_find_value(global.players, argument1);
        msg = execute_string(global.doColorCode, msg, sender, argument2);
        muted = sender.mute;
    } else if (argument1 == 254 && !global.playerInfo) {
        muted = true;
    }

    if (!muted) {
        while(string_length(msg) != 0) {
            ds_list_add(global.chatTime, current_time);

            if (string_length(msg) > 53) {
                // attempt cutting on spaces.
                for (i = 0; i < 10; i += 1) {
                    if (string_char_at(msg, 53 - i) == " ") {
                        break;
                    }
                }

                ds_list_add(global.chatLog, string_copy(msg, 1, 53 - i));
                pos = string_pos(chr(13), msg);
                if (pos == 0) {
                    color = string_copy(msg, 1, 1);
                } else {
                    color = string_copy(msg, pos + 1, 1);
                }

                msg = color + string_copy(msg, 54 - i, 255);
            } else {
               ds_list_add(global.chatLog, string_copy(msg, 1, 53));
               msg = "";
            }
        }
    }
';

// msg doColorCode(msg, sender, team)
global.doColorCode = '
    var color;
    if (string_char_at(argument0, 1) == chr(13)) {
        //argument0 = string_copy(argument0, 2, string_length(argument0) - 1);
        argument0 = sanitiseNewlines(argument0);
        argument0 = "W *" + argument1.name + argument0;
    } else {
        argument0 = sanitiseNewlines(argument0);
        if (argument1.team == TEAM_RED) {
            color = "R";
        } else if (argument1.team == TEAM_BLUE) {
            color = "B";
        } else {
            color = "W";
        }

        if (argument2 == 0) {
            if (argument1.id == ds_list_find_value(global.players, 0)) {
                argument0 = color + argument1.name + ": " + chr(13) + "O" + argument0;
            } else {
                argument0 = color + argument1.name + ": " + chr(13) + "W" + argument0;
            }
        } else {
            argument0 = color + argument1.name + ": " + argument0;
        }
    }

    return argument0;
';

// Note: chat itself uses event_user(2) because it may be faster
// getColorCode(msg)
global.getColorCode = '
    switch(string_copy(argument0, 1, 1)) {
        case "R":
            draw_set_color(make_color_rgb(237, 61, 61));
            break;
        case "B":
            draw_set_color(make_color_rgb(0, 128, 255));
            break;
        case "G":
            draw_set_color(make_color_rgb(32, 183, 28));
            break;
        case "O":
            draw_set_color(c_orange);
            break;
        case "A":
            draw_set_color(c_aqua);
            break;
        case "S":
            draw_set_color(global.chatWindow.randomColor);
            break;
        default:
            draw_set_color(c_white);
    }
';

// executeChat(msg, sender, team)
global.executeChat = '
    if (string_copy(argument0, 1, 1) != "/") {
        var sender;
        sender = ds_list_find_index(global.players, argument1);
        execute_string(global.sendChatMessage, argument0, sender, argument2);
        execute_string(global.addChatMessage, argument0, sender, argument2);
    } else {
        var arguments;
        arguments = execute_string(global.parseCommand, argument0);

        var found;
        found = false;
        if (argument1 == global.myself) {
            if (ds_map_exists(global.clientCommandMap, string_lower(ds_list_find_value(arguments, 0))))  {
                execute_string(ds_map_find_value(global.clientCommandMap, string_lower(ds_list_find_value(arguments, 0))), arguments, argument1);
                found = true;
            }
        }

        if (!found) {
            if (ds_map_exists(global.commandMap, string_lower(ds_list_find_value(arguments, 0)))) {
                if (string(ds_map_find_value(global.voteCommandMap, string_lower(ds_list_find_value(arguments, 0)))) == "0" && argument1 != global.myself) {
                    if (current_time - global.chatWindow.voteTimeout > argument1.lastVoteCall) {
                        execute_string(ds_map_find_value(global.commandMap, string_lower(ds_list_find_value(arguments, 0))), arguments, argument1);
                        argument1.lastVoteCall = current_time;
                    } else {
                        var msg;
                        msg = "OPlease wait " + string(ceil((global.chatWindow.voteTimeout - (current_time - argument1.lastVoteCall)) / 1000)) + " seconds before starting a vote.";
                        execute_string(global.sendChatMessage, msg, 255, 0, argument1);
                    }
                } else if (ds_list_find_index(global.blockedCommands, string_lower(ds_list_find_value(arguments, 0))) >= 0 &&
                           argument1 != global.myself &&
                           string_lower(ds_list_find_value(arguments, 0)) != "help") {

                    var msg;
                    msg = "OSorry this command has been blocked by the host.";
                    execute_string(global.sendChatMessage, msg, 255, 0, argument1);
                } else {
                    execute_string(ds_map_find_value(global.commandMap, string_lower(ds_list_find_value(arguments, 0))), arguments, argument1);
                }
            } else {
                var msg;
                msg = "OSorry this command does not exist. Type /help for console commands.";
                if (argument1 != global.myself) {
                    execute_string(global.sendChatMessage, msg, 255, 0, argument1);
                } else {
                    execute_string(global.addChatMessage, msg, 255, 0);
                }
            }
        }

        ds_list_destroy(arguments);
    }
';

// arguments parseCommand(cmd)
global.parseCommand = '
    var pos, quotePos, arguments, command, arg, args;
    arguments = ds_list_create();
    command = string_copy(argument0, 2, string_length(argument0) - 1);

    pos = string_pos(" ", command);
    if (pos) {
        arg = string_copy(command, 1, pos - 1);
        args = string_copy(command, pos + 1, string_length(command) - pos);
    } else {
        arg = command;
        args = "";
    }
    // Only parse arguments if its not /me
    if (string_lower(arg) != "me") {
        ds_list_add(arguments, arg);
        command = args;
        while(command != "") {
            pos = string_pos(" ", command);
            if (string_char_at(command, 1) == chr(34)) {  // argument starts with a quote
                command = string_copy(command, 2, 255); // remove the starting quote
                pos = string_pos(chr(34), string_copy(command, 1, string_length(command)));
                while(string_char_at(command, pos + 1) != " " && pos != 0) { //look for the ending quote
                    quotePos = string_pos(chr(34), string_copy(command, pos + 1, string_length(command)));
                    if (quotePos == 0) {
                        pos = 0;
                    } else {
                        pos += quotePos;
                    }
                }
                if (pos != 0) {
                    command = string_copy(command, 1, pos - 1) + string_copy(command, pos + 1, 255);
                } else if (string_char_at(command, string_length(command)) == chr(34)) {
                    command = string_copy(command, 1, string_length(command) - 1);
                }
            }

            if (pos == 0) {
                ds_list_add(arguments, command);
                command = "";
            } else {
                ds_list_add(arguments, string_copy(command, 1, pos - 1));
                command = string_copy(command, pos + 1, 255);
            }
        }
    } else {
        ds_list_add(arguments, arg);
        if (string_length(args) > 0) {
            ds_list_add(arguments, args);
        }
    }

    return arguments;
';
