// Create an object that allows people to vote 'the tf2 way'
global.voter = object_add();
object_set_depth(global.voter, -110002);

object_event_add(global.voter, ev_create, 0, '
    question = "";
    options = ds_list_create();
    optionVotes[0] = 0;
    var i;
    for (i = 1; i < 9; i += 1) {
        optionVotes[i] = 0;
    }

    total = 0;
    alarm[0] = 60 * 30 / global.delta_factor;
    done = false;
    win = -1;
    alarm[1] = 5 / global.delta_factor; //creation cooldown
    start = false;
    vote = -1;
');

object_event_add(global.voter, ev_alarm, 0, '
    instance_destroy();
');

object_event_add(global.voter, ev_alarm, 1, '
    start = true;
');

object_event_add(global.voter, ev_step, ev_step_begin, '
    if (!visible) {
        exit;
    }

    if (instance_exists(MenuController) ||
        instance_exists(BubbleMenuZ) ||
        instance_exists(BubbleMenuX) ||
        instance_exists(BubbleMenuC) ||
        instance_exists(TeamSelectController) ||
        instance_exists(ClassSelectController)) {

        exit;
    }

    if keyboard_check_pressed(ord("0")) {
        if (global.isHost) {
            visible = false; //dont destroy the vote as host, we might need it when a player joins
        } else {
            instance_destroy();
        }
    }

    if (!done && start) {
        vote = -1;
        if keyboard_check_pressed(ord("1")) {
            vote = 1;
        } else if keyboard_check_pressed(ord("2")) {
            vote = 2;
        } else if keyboard_check_pressed(ord("3")) {
            vote = 3;
        } else if keyboard_check_pressed(ord("4")) {
            vote = 4;
        } else if keyboard_check_pressed(ord("5")) {
            vote = 5;
        } else if keyboard_check_pressed(ord("6")) {
            vote = 6;
        } else if keyboard_check_pressed(ord("7")) {
            vote = 7;
        } else if keyboard_check_pressed(ord("8")) {
            vote = 8;
        } else if keyboard_check_pressed(ord("9")) {
            vote = 9;
        }

        if (vote != -1 && vote <= ds_list_size(options)) {
            done = true;
            if (!global.isHost) {
                write_ubyte(global.chatSendBuffer, 3);
                write_ubyte(global.chatSendBuffer, vote);
                PluginPacketSend(global.chatPacketID, global.chatSendBuffer);
                buffer_clear(global.chatSendBuffer);
            } else if (global.myself.canVote) {
                global.myself.canVote = false;

                with(global.chatWindow) {
                    execute_string(global.handleVote, votes, voteCommand, options, votePlayer, global.myself, other.vote);
                }

            }
        }
    }
');

object_event_add(global.voter, ev_draw, 0, '
    if (!visible) {
        exit;
    }

    var xOffset, yOffset, width, height, i;

    width = string_width(question) - 10;
    for(i=0; i < ds_list_size(options); i += 1) {
        width = max(width, string_width(ds_list_find_value(options, i)));
    }

    width = min(width, 200);
    width += 15;
    height = 45 + string_height(question) + ds_list_size(options) * 20;
    xOffset = view_xview[0] + 7;
    yOffset = max(view_yview[0] + 200 - height, view_yview[0] + 7);

    draw_set_color(c_dkgray);
    draw_set_alpha(0.8);
    draw_rectangle(xOffset, yOffset, xOffset + width, yOffset + height, false);

    draw_set_color(c_black);
    draw_set_alpha(1);
    draw_rectangle(xOffset, yOffset, xOffset + width, yOffset + height, true);

    draw_set_halign(fa_left);
    draw_set_valign(fa_top);
    draw_set_font(global.consoleFont);
    draw_set_color(c_orange);
    draw_text(xOffset + 8,yOffset + 10, question);

    draw_set_color(c_white);
    for(i=0; i < ds_list_size(options); i += 1) {
        if (done) {
            if (win == (i+1)) {
                draw_set_color(c_aqua);
            } else if (vote == (i+1)) {
                draw_set_color(c_orange);
            } else {
                draw_set_color(c_white);
            }

            if (vote == (i+1)) {
                draw_text(xOffset + 8, yOffset + 20 + string_height(question) + i * 20," > " + ds_list_find_value(options, i));
            } else {
                draw_text(xOffset + 8, yOffset + 20 + string_height(question) + i * 20, "   " + ds_list_find_value(options, i));
            }
        } else {
            draw_set_color(c_white);
            draw_text(xOffset + 8, yOffset + 20 + string_height(question) + i * 20, string(i + 1) + ". " + ds_list_find_value(options, i));
        }
        if (total and optionVotes[i]) {
            draw_set_color(c_aqua);
            draw_rectangle(xOffset + 8, yOffset + 20 + string_height(question) + i * 20 + 15, xOffset + 8 + (width - 30) * (optionVotes[i] / total), yOffset + 20 + string_height(question) + i * 20 + 17, false);
        }
    }
    draw_set_color(c_orange);
    draw_text(xOffset + 8, yOffset + 20 + string_height(question) + i * 20, "0. close | " + string(ceil(alarm[0] / 30 * global.delta_factor)) + "s");
    draw_set_font(global.gg2Font);
');

// handleVote(votes, voteCommand, options, votePlayer, sender, vote)
global.handleVote = '
    var votes, voteCommand, _options, votePlayer, sender, vote;
    votes = argument0;
    _voteCommand = argument1;
    _options = argument2;
    _votePlayer = argument3;
    sender = argument4;
    vote = argument5;

    if (ds_list_size(_voteCommand) > 0) {
        if (_votePlayer == sender) {
            global.chatWindow.alarm[0] = -1;

            ds_list_add(votes, vote);
            execute_string(ds_map_find_value(global.voteCommandMap, ds_list_find_value(_voteCommand, 0)), _voteCommand, _options, votes, sender);
            ds_list_clear(votes);

            // Important! votePlayer commands have to clear the voteCommand themselves!
        } else if (_votePlayer == noone) {
            ds_list_add(votes, vote);

            // tell plebs about the votes IN REAL TIME
            with(Player) {
                if (hasChat && !(global.isHost and id == global.myself) && mayVote) {
                    write_ubyte(global.chatSendBuffer, 203);
                    write_ubyte(global.chatSendBuffer, vote - 1);
                    PluginPacketSendTo(global.chatPacketID, global.chatSendBuffer, id);
                    buffer_clear(global.chatSendBuffer);
                }
            }

            // if Im not a pleb, tell me IN REALER TIME!!!!
            if (global.isHost) {
                with(global.voter) {
                    optionVotes[vote - 1] += 1;
                    total += 1;
                }
            }

            if ds_list_size(votes) >= ds_list_size(global.players) {
                global.chatWindow.alarm[0] = 1;
            }
        }
    }
';

// sendVote(time, question, options, target)
global.sendVote = '
    var time, _question, _options, target;
    time = argument0;
    _question = argument1;
    _options = argument2;
    target = argument3;

    global.chatWindow.alarm[0] = time / global.delta_factor;
    if (target != Player) {
        global.chatWindow.votePlayer = target;
    }

    if (target == global.myself || target == Player) {
        global.myself.canVote = true;

        with(global.voter) {
            instance_destroy();
        }
        instance_create(0, 0, global.voter);

        with(global.voter) {
            ds_list_clear(options);
            question = _question;
            var i;
            for(i=0; i < ds_list_size(_options) && i < 9; i += 1) {
                ds_list_add(options, ds_list_find_value(_options, i));
            }
            alarm[0] = time / global.delta_factor;
        }
    }

    if (target != global.myself) {
        write_ubyte(global.chatSendBuffer, 200);
        write_ubyte(global.chatSendBuffer, min(255, string_length(_question)));
        write_string(global.chatSendBuffer, string_copy(_question, 0, 255));
        write_ubyte(global.chatSendBuffer, ds_list_size(_options));

        var i;
        for(i = 0; i < ds_list_size(_options); i += 1) {
            write_ubyte(global.chatSendBuffer, min(255, string_length(ds_list_find_value(_options, i))));
            write_string(global.chatSendBuffer, string_copy(ds_list_find_value(_options, i), 0, 255));
        }
        write_ushort(global.chatSendBuffer, time);

        with(target) {
            // dont tell people who may not vote at the moment
            if (hasChat = true && mayVote) {
                canVote = true;
                PluginPacketSendTo(global.chatPacketID, global.chatSendBuffer, id);
            }
        }
        buffer_clear(global.chatSendBuffer);
    }
';

// sendVoteResults(win, votePlayer)
global.sendVoteResults = '
    var _win, _votePlayer;
    _win = argument0;
    _votePlayer = argument1;

    global.chatWindow.alarm[0] = -1;
    write_ubyte(global.chatSendBuffer, 201);
    write_ubyte(global.chatSendBuffer, _win);
    if (_votePlayer == noone) {
        with(Player) {
            if (hasChat == true && mayVote == true) {
                PluginPacketSendTo(global.chatPacketID, global.chatSendBuffer, id);
            }
        }
        buffer_clear(global.chatSendBuffer);
    } else {
        with(_votePlayer) {
            if (hasChat == true) {
                PluginPacketSendTo(global.chatPacketID, global.chatSendBuffer, id);
            }
        }
        buffer_clear(global.chatSendBuffer);
    }

    if (_votePlayer == global.myself || _votePlayer == noone) {
        if (_win == 0) {
            with(global.voter) {
                instance_destroy();
            }

        } else {
            with(global.voter) {
                win = _win;
                done = true;
                alarm[0] = 90 / global.delta_factor;
            }
        }
    }
';

// findPlayer(gidOrName, command, sender)
global.findPlayer = '
    var _name, _gid, command, sender, count, target, msg;
    _name = argument0;
    command = argument1;
    sender = argument2;
    count = 0;
    target = noone;

    if (is_real(_name)) {
        if (_name <= 0) {
            execute_string(global.selectPlayer, command, global.chatWindow.voteCommand, global.chatWindow.options, sender);
            return noone;
        }
    }

    if (string_char_at(_name, 1) == chr(13)) {
        _gid = real(string_copy(_name, 2, string_length(_name) - 1));
        with(Player) {
            if (gid == _gid) {
                return id;
            }
        }
    }

    with(Player) {
        if (name == _name) {
            return id;
        }
    }

    with(Player) {
        if (string_count(string_lower(name), string_lower(_name)) > 0) {
            target = id;
            count += 1;
        }
    }

    if (count == 1) {
        return target;
    } else if (count > 1) {
        msg = "OThere are multiple players with this name, please be more specific or use this command with no arguments.";
    } else {
        msg = "OThere are no players with this name, please try again or use this command with no arguments.";
    }

    if (sender == global.myself) {
        execute_string(global.addChatMessage, msg, 255, 0, sender);
    } else {
        execute_string(global.sendChatMessage, msg, 255, 0, sender);
    }

    return noone;
';

// selectPlayer(command, voteCommand, options, sender)
global.selectPlayer = '
    var command, _voteCommand, _options, sender;
    command = argument0;
    _voteCommand = argument1;
    _options = argument2;
    sender = argument3;

    if (global.chatWindow.alarm[0] > 0) {
        var msg, question;
        msg = "OYou may not call vote at the moment. Please wait at least " + string(ceil(global.chatWindow.alarm[0] / 30 * global.delta_factor)) + " seconds.";

        if (sender == global.myself) {
            execute_string(global.addChatMessage, msg, 255, 0, sender);
        } else {
            execute_string(global.sendChatMessage, msg, 255, 0, sender);
        }
     } else {
        ds_list_clear(_voteCommand);
        ds_list_add(_voteCommand, "select");
        ds_list_add(_voteCommand, command);

        question = "Select a player.";
        ds_list_clear(_options);
        with(Player) {
            ds_list_add(_options, sanitiseNewlines(name) + " (" + string(floor(stats[POINTS])) + ")");
            ds_list_add(_voteCommand, chr(13) + string(gid));
            if (ds_list_size(_options) >= 8) {
                break;
            }
        }
        if (ds_list_size(global.players) >= 8) {
            ds_list_add(_options, "Next page");
        }

        execute_string(global.sendVote, 30 * 30, question, _options, sender);
    }
';

// voteCommand(votecommand, options, votes, sender)
ds_map_add(global.voteCommandMap, 'select', '
    var _voteCommand, _options, _votes, _vote, sender;
    _voteCommand = argument0;
    _options = argument1;
    _votes = argument2;

    _vote = ds_list_find_value(_votes, ds_list_size(_votes) - 1);
    sender = argument3;

    //clear the vote menu
    execute_string(global.sendVoteResults, 0, sender);

    ds_list_clear(_options);
    if (_vote == 9) { // next page
        var tmpCommand, lastPlayer;
        tmpCommand = ds_list_find_value(_voteCommand, 1);
        lastPlayer = ds_list_find_value(_voteCommand, ds_list_size(_voteCommand) - 1);

        ds_list_clear(_voteCommand);
        ds_list_add(_voteCommand, "select");
        ds_list_add(_voteCommand, tmpCommand);

        var found, i;
        i = 0;
        found = false;
        with(Player) {
            if (found) {
                ds_list_add(_options, sanitiseNewlines(name) + " (" + string(floor(stats[POINTS])) + ")");
                ds_list_add(_voteCommand, chr(13) + string(gid));
                if (ds_list_size(_options) >= 8) {
                    break;
                }
            }
            else if (chr(13) + string(gid) == lastPlayer) {
                found = true;
                i += 1;
            }
        }

        if (ds_list_size(_options) == 0) {
            var msg;
            msg = "OAn unknown error occurred, please try again.";
            if (sender == global.myself) {
                execute_string(global.addChatMessage, msg, 255, 0, sender);
            } else {
                execute_string(global.sendChatMessage, msg, 255, 0, sender);
            }
        } else {
            if (ds_list_size(global.players) >= 8 + i) {
                ds_list_add(_options, "Next page");
            }

            var question;
            question = "Select a player.";
            execute_string(global.sendVote, 30 * 30, question, _options, sender);
        }
    } else {
        global.chatWindow.votePlayer = noone;

        var arguments, code;
        arguments = ds_list_create();
        ds_list_add(arguments, ds_list_find_value(_voteCommand, 1));
        ds_list_add(arguments, ds_list_find_value(_voteCommand, _vote + 1));

        code = ds_map_find_value(global.commandMap, ds_list_find_value(_voteCommand, 1));
        if (string(code) == "0") {
            execute_string(ds_map_find_value(global.commandMap, ds_list_find_value(_voteCommand, 1)), arguments, sender);
        } else {
            execute_string(code, arguments, sender);
        }
        ds_list_destroy(arguments);
    }
');
